// SimDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sim.h"
#include "SimDlg.h"
#include "OptionsDlg.h"
#include "math.h"
#include "StatLink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CStaticLink	m_wndLink5;
	CStaticLink	m_wndLink4;
	CStaticLink	m_wndLink3;
	CStaticLink	m_wndLink2;
	CStaticLink	m_wndLink1;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_TUNER, m_wndLink5);
	DDX_Control(pDX, IDC_KATZEN, m_wndLink4);
	DDX_Control(pDX, IDC_BENG, m_wndLink3);
	DDX_Control(pDX, IDC_UUJ, m_wndLink2);
	DDX_Control(pDX, IDC_CKM, m_wndLink1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimDlg dialog

CSimDlg::CSimDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSimDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSimDlg)
	m_sTxHistory = _T("");


	m_EnableCH1 = TRUE;
	m_EnableCH2 = FALSE;
	m_EnableCH3 = FALSE;
	m_EnableCH4 = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nCH1WaveType = SINE;
	m_nCH2WaveType = SQUARE;
	m_nCH3WaveType = RANDOM;
	m_nCH4WaveType = SINE;



}

void CSimDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSimDlg)
	DDX_Control(pDX, IDC_EDIT_TX, m_Ctrl_TXHIST);
	DDX_Text(pDX, IDC_EDIT_TX, m_sTxHistory);
	DDX_Check(pDX, IDC_CH1, m_EnableCH1);
	DDX_Check(pDX, IDC_CH2, m_EnableCH2);
	DDX_Check(pDX, IDC_CH3, m_EnableCH3);
	DDX_Check(pDX, IDC_CH4, m_EnableCH4);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSimDlg, CDialog)
	//{{AFX_MSG_MAP(CSimDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_BN_CLICKED(IDC_OPTIONS, OnOptions)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_ENABLE_DISABLE, OnEnableDisable)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SINE_CH1, OnWaveCH1)
	ON_BN_CLICKED(IDC_SINE_CH2, OnWaveCH2)
	ON_BN_CLICKED(IDC_SINE_CH3, OnWaveCH3)
	ON_BN_CLICKED(IDC_SINE_CH4, OnWaveCH4)
	ON_BN_CLICKED(IDC_SQUARE_CH1, OnWaveCH1)
	ON_BN_CLICKED(IDC_RAND_CH1, OnWaveCH1)
	ON_BN_CLICKED(IDC_SQUARE_CH2, OnWaveCH2)
	ON_BN_CLICKED(IDC_RAN_CH2, OnWaveCH2)
	ON_BN_CLICKED(IDC_SQUARE_CH3, OnWaveCH3)
	ON_BN_CLICKED(IDC_RAND_CH3, OnWaveCH3)
	ON_BN_CLICKED(IDC_SQUARE_CH4, OnWaveCH4)
	ON_BN_CLICKED(IDC_RAND_CH4, OnWaveCH4)
	ON_COMMAND(ID_HELP_COLINSHOMEPAGE, OnHelpColinshomepage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimDlg message handlers

BOOL CSimDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	m_Enable = false;
	GetDlgItem(IDC_ENABLE_DISABLE)->SetWindowText(_T("&Enable"));

	InitalCom();

	SetDlgItemText(IDC_FREQ_CH1,_T("50.0"));
	SetDlgItemInt(IDC_AMP_CH1,5);

	SetDlgItemText(IDC_FREQ_CH2,_T("75.0"));
	SetDlgItemInt(IDC_AMP_CH2,3);

	SetDlgItemText(IDC_FREQ_CH3,_T("25.0"));
	SetDlgItemInt(IDC_AMP_CH3,2);

	SetDlgItemText(IDC_FREQ_CH4,_T("100.0"));
	SetDlgItemInt(IDC_AMP_CH4,4);

	SetDlgItemInt(IDC_SAMPLERATE,1000);


	ch1_pos = 0;
	k = 1;
	ch2_pos = 0;
	k2 = 1;
	ch3_pos = 0;
	k3 = 1;
	ch4_pos = 0;
	k4 = 1;

	t1 = 1.0;
	t2 = 1.0;
	t3 = 1.0;
	t4 = 1.0;

	CheckDlgButton(IDC_REALTIME,BST_CHECKED);


	SetTimer(ID_TIMER_COMS,1000,NULL);	 // Call communication protocol every 1s
	SetTimer(ID_TIMER_UPDATE,200,NULL);  // Update Display every 100ms



	Update();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSimDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSimDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSimDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSimDlg::OnHelpAbout() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

void CSimDlg::OnOptions() 
{
	COptionsDlg dlg;
	dlg.DoModal();

	/* Reinital Comms */
	CloseHandle (m_hCom);
	InitalCom();
}

void CSimDlg::InitalCom()
{
	/* 24/12/01 */ 


	CSimApp* pApp = (CSimApp*)AfxGetApp();

	int temp_int;
	DWORD baud;
	BYTE partiy, byte, StopBits;

	temp_int = pApp->GetProfileInt("Config","COM",D_COM);
	if(temp_int == 0)		m_sComPort = "Com1";
	else if(temp_int == 1) 	m_sComPort = "Com2";
	else if(temp_int == 2) 	m_sComPort = "Com3";
	else if(temp_int == 3) 	m_sComPort = "Com4";
	else 					m_sComPort = "Com1";

	temp_int = pApp->GetProfileInt("Config","Baud",D_BAUD);
	if (temp_int == 0)		baud = 1200;
	else if(temp_int == 1)	baud = 2400;
	else if(temp_int == 2)	baud = 4800;
	else if(temp_int == 3)	baud = 9600;
	else if(temp_int == 4) 	baud = 14400;
	else if(temp_int == 5) 	baud = 19200;
	else if(temp_int == 6) 	baud = 32768;
	else if(temp_int == 7) 	baud = 38400;
	else if(temp_int == 8) 	baud = 57600;
	else if(temp_int == 9)  baud = 115200;
	else baud = 9600;

	temp_int = pApp->GetProfileInt("Config","Byte Size",D_BYTE);
	if(temp_int == 0)		byte = 7;
	else if(temp_int == 1) 	byte = 8;
	else 					byte = 8;

	temp_int = pApp->GetProfileInt("Config","Parity",D_PARITY);
	if(temp_int == 0)		partiy = EVENPARITY;
	else if(temp_int == 1) 	partiy = MARKPARITY;
	else if(temp_int == 2) 	partiy = NOPARITY;
	else if(temp_int == 3) 	partiy = ODDPARITY;
	else if(temp_int == 4) 	partiy = SPACEPARITY;
	else partiy = NOPARITY;

	temp_int = pApp->GetProfileInt("Config","Stop Bits",D_STOP);
	if(temp_int == 0)		StopBits = ONESTOPBIT;
	else if(temp_int == 1) 	StopBits = ONE5STOPBITS;
	else if(temp_int == 2) 	StopBits = TWOSTOPBITS;
	else 					StopBits = ONESTOPBIT;


	m_hCom = CreateFile(m_sComPort, 
		GENERIC_READ | GENERIC_WRITE,
		0, // exclusive access
		NULL, // no security
		OPEN_EXISTING,
		0/*FILE_FLAG_OVERLAPPED*/, // no overlapped I/O
		NULL); // null template 


	// Check the returned handle for INVALID_HANDLE_VALUE and then 
	// set the buffer sizes.

	m_bPortReady = SetupComm(m_hCom, 1000, 1000); // set buffer sizes


	//  Port settings are specified in a Data Communication 
	//  Block (DCB). The easiest way to initialize a DCB is to call 
	//  GetCommState to fill in its default values, override the values 
	//  that you want to change and then call SetCommState to set the values.
	
	m_bPortReady = GetCommState(m_hCom, &m_dcb);
	m_dcb.BaudRate = baud;
	m_dcb.ByteSize = byte;
	m_dcb.Parity = partiy;
	m_dcb.StopBits = ONESTOPBIT;

	m_bPortReady = SetCommState(m_hCom, &m_dcb);

	// Communication timeouts are optional but can be set similarly 
	// to DCB values:

	m_bPortReady = GetCommTimeouts (m_hCom, &m_CommTimeouts);

	m_CommTimeouts.ReadIntervalTimeout = 10;
	m_CommTimeouts.ReadTotalTimeoutConstant = 10;
	m_CommTimeouts.ReadTotalTimeoutMultiplier = 10;
	m_CommTimeouts.WriteTotalTimeoutConstant = 10;
	m_CommTimeouts.WriteTotalTimeoutMultiplier = 10;

	m_bPortReady = SetCommTimeouts (m_hCom, &m_CommTimeouts);
}

bool CSimDlg::readchr(unsigned char *c)
{
	unsigned char   Buffer[128];

	unsigned long a = 0;
	bReadRC = ReadFile(m_hCom, &Buffer, 1, &a, NULL);

	if (a == 0) return false; // No char recived
	else
	{
		*c = Buffer[0];
		return true;
	}
}


void CSimDlg::trans(char c)
{
	char buffer[2];
	buffer[0] = c;
	bWriteRC = WriteFile (m_hCom, buffer, 1,&iBytesWritten,NULL);
}

void CSimDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	KillTimer(ID_TIMER_COMS);
	KillTimer(ID_TIMER_UPDATE);

	CloseHandle (m_hCom);

	
}



void CSimDlg::OnEnableDisable() 
{
	if (m_Enable == false)
	{
		m_Enable = true;
		GetDlgItem(IDC_ENABLE_DISABLE)->SetWindowText(_T("&Disable"));
	}
	else
	{
		m_Enable = false;
		GetDlgItem(IDC_ENABLE_DISABLE)->SetWindowText(_T("&Enable"));
	}
}

void CSimDlg::OnTimer(UINT nIDEvent) 
{

	double timer,freq;

	if(nIDEvent == ID_TIMER_COMS)
	{
		KillTimer(ID_TIMER_COMS);
		if (m_Enable == true) ComProtocolTop();

		/** Set the timer based on the value in the sample rate edit box */
		freq = (double)GetDlgItemInt(IDC_SAMPLERATE);
		timer = (1.0/freq)*10000.0;
		SetTimer(ID_TIMER_COMS,(int)timer,NULL);
	}


	if(nIDEvent == ID_TIMER_UPDATE)
	{
		Update();
	}



	CDialog::OnTimer(nIDEvent);
}

void CSimDlg::ComProtocolTop()
{
	int i;
	UpdateData(TRUE);


	/** RealTime **/
	if (IsDlgButtonChecked(IDC_REALTIME))
	{	
		for (i = 1; i<10;i++)
		{
			if (m_EnableCH1 == TRUE)	SimCH1();
			if (m_EnableCH2 == TRUE)	SimCH2();
			if (m_EnableCH3 == TRUE)	SimCH3();
			if (m_EnableCH4 == TRUE)	SimCH4();
		}
	}
}

void CSimDlg::SimCH1()
{
	/** 15/03/2002, by CKM Version 1.6 */

	unsigned short temp;
	unsigned char ch1_b1, ch1_b2;

	double value;
	double freq = 50.0;
	double amp;

	amp =  (double)GetDlgItemInt(IDC_AMP_CH1,NULL,TRUE);
	freq = (double)GetDlgItemInt(IDC_FREQ_CH1) * 200;


	if(m_nCH1WaveType == SINE)
	{
		value = amp * sin((2*3.14159 *freq *t1));
		temp =  (unsigned short)(512.0+(102.4 * value));
		t1 = t1 + 1;
		if (t1 > freq) t1 = 1.0;
	}

	if(m_nCH1WaveType == SQUARE)
	{
		value = 10 * sin((2*3.14159 *freq *t1));
		if (value >0) value = amp;
		else value = amp * -1.0;
		temp =  (unsigned short)(512.0+(102.39 * value));
		t1 = t1 + 1;
		if (t1 > freq) t1 = 1.0;
	}

	if(m_nCH1WaveType == RANDOM)
	{
		temp = rand()%1024;	
	}

	ch1_b1 = temp >> 5;
	ch1_b1 = ch1_b1 & 0x1F; // & 00011111
		
	ch1_b2 = (unsigned char)temp;
	ch1_b2 = ch1_b2 | 0x80; // | 1000 0000

	trans (ch1_b1);
	trans (ch1_b2);
}

void CSimDlg::SimCH2()
{

	/** 15/03/2002, by CKM Version 1.6 */

	unsigned short temp;
	unsigned char b1, b2;

	double value;
	double freq = 50.0;
	double amp;

	amp =  (double)GetDlgItemInt(IDC_AMP_CH2,NULL,TRUE);
	freq = (double)GetDlgItemInt(IDC_FREQ_CH2) * 200;


	if(m_nCH2WaveType == SINE)
	{
		value = amp * sin((2*3.14159 *freq *t2));
		temp =  (unsigned short)(512.0+(102.4 * value));
		t2 = t2 + 1.0;
		if (t2 > freq) t2 = 0.0;
	}

	if(m_nCH2WaveType == SQUARE)
	{
		value = 10 * sin((2*3.14159 *freq *t2));
		if (value >0) value = amp;
		else value = amp * -1.0;
		temp =  (unsigned short)(512.0+(102.39 * value));
		t2 = t2 + 1.0;
		if (t2 > freq) t2 = 0.0;
	}

	if(m_nCH2WaveType == RANDOM)
	{
		temp = rand()%1024;	
	}



	b1 = temp >> 5;
	b1 = b1 & 0x1F; // & 00011111
	b1 = b1 | 0x20; // | 0010 0000

	b2 = (unsigned char)temp;
	b2 = b2 | 0xA0; // | 1010 0000
	
	trans (b1);
	trans (b2);


}

void CSimDlg::SimCH3()
{

	/** 15/03/2002, by CKM Version 1.6 */

	unsigned short temp;
	unsigned char b1, b2;

	double value;
	double freq = 50.0;
	double amp;

	amp =  (double)GetDlgItemInt(IDC_AMP_CH3,NULL,TRUE);
	freq = (double)GetDlgItemInt(IDC_FREQ_CH3) * 200;


	if(m_nCH3WaveType == SINE)
	{
		value = amp * sin((2*3.14159 *freq *t3));
		temp =  (unsigned short)(512.0+(102.4 * value));
		t3 = t3 + 1.0;
		if (t3 > freq) t3 = 0.0;
	}

	if(m_nCH3WaveType == SQUARE)
	{
		value = 10 * sin((2*3.14159 *freq *t3));
		if (value >0) value = amp;
		else value = amp * -1.0;
		temp =  (unsigned short)(512.0+(102.39 * value));
		t3 = t3 + 1.0;
		if (t3 > freq) t3 = 0.0;
	}

	if(m_nCH3WaveType == RANDOM)
	{
		temp = rand()%1024;	
	}



	b1 = temp >> 5;
	b1 = b1 & 0x1F; // & 00011111
	b1 = b1 | 0x40; // | 0100 0000

	b2 = (unsigned char)temp;
	b2 = b2 | 0xC0; // | 1100 0000
	
	trans (b1);
	trans (b2);


}

void CSimDlg::SimCH4()
{
	/** 15/03/2002, by CKM Version 1.6 */

	unsigned short temp;
	unsigned char b1, b2;

	double value;
	double freq = 50.0;
	double amp;

	amp =  (double)GetDlgItemInt(IDC_AMP_CH4,NULL,TRUE);
	freq = (double)GetDlgItemInt(IDC_FREQ_CH4) * 200;


	if(m_nCH4WaveType == SINE)
	{
		value = amp * sin((2*3.14159 *freq *t4));
		temp =  (unsigned short)(512.0+(102.4 * value));
		t4 = t4 + 1.0;
		if (t4 > freq) t4 = 0.0;
	}

	if(m_nCH4WaveType == SQUARE)
	{
		value = 10 * sin((2*3.14159 *freq *t4));
		if (value >0) value = amp;
		else value = amp * -1.0;
		temp =  (unsigned short)(512.0+(102.39 * value));
		t4 = t4 + 1.0;
		if (t4 > freq) t4 = 0.0;
	}

	if(m_nCH4WaveType == RANDOM)
	{
		temp = rand()%1024;	
	}



	b1 = temp >> 5;
	b1 = b1 & 0x1F; // & 00011111
	b1 = b1 | 0x60; // | 0110 0000

	b2 = (unsigned char)temp;
	b2 = b2 | 0xE0; // | 1110 0000
	
	trans (b1);
	trans (b2);
}



void CSimDlg::Update()
{

	switch(m_nCH1WaveType)
	{
		case SINE: 
		default:
			CheckDlgButton(IDC_SINE_CH1,BST_CHECKED);
			CheckDlgButton(IDC_SQUARE_CH1,BST_UNCHECKED);
			CheckDlgButton(IDC_RAND_CH1,BST_UNCHECKED);
			GetDlgItem(IDC_FREQ_CH1)->EnableWindow(TRUE);
			GetDlgItem(IDC_AMP_CH1)->EnableWindow(TRUE);
			break;

		case SQUARE: 
			CheckDlgButton(IDC_SINE_CH1,BST_UNCHECKED);
			CheckDlgButton(IDC_SQUARE_CH1,BST_CHECKED);
			CheckDlgButton(IDC_RAND_CH1,BST_UNCHECKED);
			GetDlgItem(IDC_FREQ_CH1)->EnableWindow(TRUE);
			GetDlgItem(IDC_AMP_CH1)->EnableWindow(TRUE);
			break;

		case RANDOM: 
		
			CheckDlgButton(IDC_SINE_CH1,BST_UNCHECKED);
			CheckDlgButton(IDC_SQUARE_CH1,BST_UNCHECKED);
			CheckDlgButton(IDC_RAND_CH1,BST_CHECKED);
			GetDlgItem(IDC_FREQ_CH1)->EnableWindow(FALSE);
			GetDlgItem(IDC_AMP_CH1)->EnableWindow(FALSE);
			break;
	}

	switch(m_nCH2WaveType)
	{
		case SINE: 
		default:
			CheckDlgButton(IDC_SINE_CH2,BST_CHECKED);
			CheckDlgButton(IDC_SQUARE_CH2,BST_UNCHECKED);
			CheckDlgButton(IDC_RAN_CH2,BST_UNCHECKED);
			GetDlgItem(IDC_FREQ_CH2)->EnableWindow(TRUE);
			GetDlgItem(IDC_AMP_CH2)->EnableWindow(TRUE);
			break;

		case SQUARE: 
			CheckDlgButton(IDC_SINE_CH2,BST_UNCHECKED);
			CheckDlgButton(IDC_SQUARE_CH2,BST_CHECKED);
			CheckDlgButton(IDC_RAN_CH2,BST_UNCHECKED);
			GetDlgItem(IDC_FREQ_CH2)->EnableWindow(TRUE);
			GetDlgItem(IDC_AMP_CH2)->EnableWindow(TRUE);
			break;

		case RANDOM: 
		
			CheckDlgButton(IDC_SINE_CH2,BST_UNCHECKED);
			CheckDlgButton(IDC_SQUARE_CH2,BST_UNCHECKED);
			CheckDlgButton(IDC_RAN_CH2,BST_CHECKED);
			GetDlgItem(IDC_FREQ_CH2)->EnableWindow(FALSE);
			GetDlgItem(IDC_AMP_CH2)->EnableWindow(FALSE);
			break;
	}

	switch(m_nCH3WaveType)
	{
		case SINE: 
		default:
			CheckDlgButton(IDC_SINE_CH3,BST_CHECKED);
			CheckDlgButton(IDC_SQUARE_CH3,BST_UNCHECKED);
			CheckDlgButton(IDC_RAND_CH3,BST_UNCHECKED);
			GetDlgItem(IDC_FREQ_CH3)->EnableWindow(TRUE);
			GetDlgItem(IDC_AMP_CH3)->EnableWindow(TRUE);
			break;

		case SQUARE: 
			CheckDlgButton(IDC_SINE_CH3,BST_UNCHECKED);
			CheckDlgButton(IDC_SQUARE_CH3,BST_CHECKED);
			CheckDlgButton(IDC_RAND_CH3,BST_UNCHECKED);
			GetDlgItem(IDC_FREQ_CH3)->EnableWindow(TRUE);
			GetDlgItem(IDC_AMP_CH3)->EnableWindow(TRUE);
			break;

		case RANDOM: 
		
			CheckDlgButton(IDC_SINE_CH3,BST_UNCHECKED);
			CheckDlgButton(IDC_SQUARE_CH3,BST_UNCHECKED);
			CheckDlgButton(IDC_RAND_CH3,BST_CHECKED);
			GetDlgItem(IDC_FREQ_CH3)->EnableWindow(FALSE);
			GetDlgItem(IDC_AMP_CH3)->EnableWindow(FALSE);
			break;
	}

	switch(m_nCH4WaveType)
	{
		case SINE: 
		default:
			CheckDlgButton(IDC_SINE_CH4,BST_CHECKED);
			CheckDlgButton(IDC_SQUARE_CH4,BST_UNCHECKED);
			CheckDlgButton(IDC_RAND_CH4,BST_UNCHECKED);
			GetDlgItem(IDC_FREQ_CH4)->EnableWindow(TRUE);
			GetDlgItem(IDC_AMP_CH4)->EnableWindow(TRUE);
			break;

		case SQUARE: 
			CheckDlgButton(IDC_SINE_CH4,BST_UNCHECKED);
			CheckDlgButton(IDC_SQUARE_CH4,BST_CHECKED);
			CheckDlgButton(IDC_RAND_CH4,BST_UNCHECKED);
			GetDlgItem(IDC_FREQ_CH4)->EnableWindow(TRUE);
			GetDlgItem(IDC_AMP_CH4)->EnableWindow(TRUE);
			break;

		case RANDOM: 
		
			CheckDlgButton(IDC_SINE_CH4,BST_UNCHECKED);
			CheckDlgButton(IDC_SQUARE_CH4,BST_UNCHECKED);
			CheckDlgButton(IDC_RAND_CH4,BST_CHECKED);
			GetDlgItem(IDC_FREQ_CH4)->EnableWindow(FALSE);
			GetDlgItem(IDC_AMP_CH4)->EnableWindow(FALSE);
			break;
	}

	if (!IsDlgButtonChecked(IDC_CH1)) // Disable all Ch1 controls if disabled 
	{
		GetDlgItem(IDC_SINE_CH1)->EnableWindow(FALSE);
		GetDlgItem(IDC_SQUARE_CH1)->EnableWindow(FALSE);
		GetDlgItem(IDC_RAND_CH1)->EnableWindow(FALSE);
		GetDlgItem(IDC_FREQ_CH1)->EnableWindow(FALSE);
		GetDlgItem(IDC_AMP_CH1)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_SINE_CH1)->EnableWindow(TRUE);
		GetDlgItem(IDC_SQUARE_CH1)->EnableWindow(TRUE);
		GetDlgItem(IDC_RAND_CH1)->EnableWindow(TRUE);
	}

	if (!IsDlgButtonChecked(IDC_CH2)) // Disable all Ch2 controls if disabled 
	{
		GetDlgItem(IDC_SINE_CH2)->EnableWindow(FALSE);
		GetDlgItem(IDC_SQUARE_CH2)->EnableWindow(FALSE);
		GetDlgItem(IDC_RAN_CH2)->EnableWindow(FALSE);
		GetDlgItem(IDC_FREQ_CH2)->EnableWindow(FALSE);
		GetDlgItem(IDC_AMP_CH2)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_SINE_CH2)->EnableWindow(TRUE);
		GetDlgItem(IDC_SQUARE_CH2)->EnableWindow(TRUE);
		GetDlgItem(IDC_RAN_CH2)->EnableWindow(TRUE);
	}

	if (!IsDlgButtonChecked(IDC_CH3)) // Disable all Ch3 controls if disabled 
	{
		GetDlgItem(IDC_SINE_CH3)->EnableWindow(FALSE);
		GetDlgItem(IDC_SQUARE_CH3)->EnableWindow(FALSE);
		GetDlgItem(IDC_RAND_CH3)->EnableWindow(FALSE);
		GetDlgItem(IDC_FREQ_CH3)->EnableWindow(FALSE);
		GetDlgItem(IDC_AMP_CH3)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_SINE_CH3)->EnableWindow(TRUE);
		GetDlgItem(IDC_SQUARE_CH3)->EnableWindow(TRUE);
		GetDlgItem(IDC_RAND_CH3)->EnableWindow(TRUE);
	}

	if (!IsDlgButtonChecked(IDC_CH4)) // Disable all Ch4 controls if disabled 
	{
		GetDlgItem(IDC_SINE_CH4)->EnableWindow(FALSE);
		GetDlgItem(IDC_SQUARE_CH4)->EnableWindow(FALSE);
		GetDlgItem(IDC_RAND_CH4)->EnableWindow(FALSE);
		GetDlgItem(IDC_FREQ_CH4)->EnableWindow(FALSE);
		GetDlgItem(IDC_AMP_CH4)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_SINE_CH4)->EnableWindow(TRUE);
		GetDlgItem(IDC_SQUARE_CH4)->EnableWindow(TRUE);
		GetDlgItem(IDC_RAND_CH4)->EnableWindow(TRUE);
	}

}

void CSimDlg::OnWaveCH1() 
{
	KillTimer(ID_TIMER_UPDATE);
	if (IsDlgButtonChecked(IDC_SINE_CH1)) m_nCH1WaveType = SINE;
	if (IsDlgButtonChecked(IDC_SQUARE_CH1)) m_nCH1WaveType = SQUARE;
	if (IsDlgButtonChecked(IDC_RAND_CH1)) m_nCH1WaveType = RANDOM;
	
	SetTimer(ID_TIMER_UPDATE,200,NULL);

}

void CSimDlg::OnWaveCH2() 
{
	KillTimer(ID_TIMER_UPDATE);
	if (IsDlgButtonChecked(IDC_SINE_CH2)) m_nCH2WaveType = SINE;
	if (IsDlgButtonChecked(IDC_SQUARE_CH2)) m_nCH2WaveType = SQUARE;
	if (IsDlgButtonChecked(IDC_RAN_CH2)) m_nCH2WaveType = RANDOM;
	
	SetTimer(ID_TIMER_UPDATE,200,NULL);
}

void CSimDlg::OnWaveCH3() 
{
	KillTimer(ID_TIMER_UPDATE);
	if (IsDlgButtonChecked(IDC_SINE_CH3)) m_nCH3WaveType = SINE;
	if (IsDlgButtonChecked(IDC_SQUARE_CH3)) m_nCH3WaveType = SQUARE;
	if (IsDlgButtonChecked(IDC_RAND_CH3)) m_nCH3WaveType = RANDOM;
	
	SetTimer(ID_TIMER_UPDATE,200,NULL);
}

void CSimDlg::OnWaveCH4() 
{
	KillTimer(1);
	if (IsDlgButtonChecked(IDC_SINE_CH4)) m_nCH4WaveType = SINE;
	if (IsDlgButtonChecked(IDC_SQUARE_CH4)) m_nCH4WaveType = SQUARE;
	if (IsDlgButtonChecked(IDC_RAND_CH4)) m_nCH4WaveType = RANDOM;
	
	SetTimer(ID_TIMER_UPDATE,200,NULL);
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	/* Setup HyperLinks */

	m_wndLink1.m_link = _T("http://website.lineone.net/~colin_mccord/");
	m_wndLink2.m_link = _T("http://www.ulst.ac.uk");
	m_wndLink3.m_link = _T("http://www.ulst.ac.uk/courses/modules/courses/C190UJ.html");
	m_wndLink4.m_link = _T("http://www.engj.ulst.ac.uk/sidk/");
	m_wndLink5.m_link = _T("http://tree.engj.ulst.ac.uk/");

	m_wndLink1.SubclassDlgItem(IDC_CKM, this);
	m_wndLink2.SubclassDlgItem(IDC_UUJ, this);
	m_wndLink3.SubclassDlgItem(IDC_BENG, this);
	m_wndLink4.SubclassDlgItem(IDC_KATZEN, this);
	m_wndLink5.SubclassDlgItem(IDC_TUNER, this);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSimDlg::OnHelpColinshomepage() 
{
	ShellExecute(::GetDesktopWindow(),_T("open"),_T("http://myweb.tiscali.co.uk/mccord/"),NULL,NULL,SW_MAXIMIZE);		
}
